﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=6.51
@EndOfDesignText@
'Custom View class
#Event: ChangeValue (Value As String)

Sub Class_Globals
	Private fx As JFX
	Private mEventName As String 'ignore
	Private mCallBack As Object 'ignore
	Private mBase As Pane
	
	Private TF As TextField
	Private LabelDigit As Label
	Private MyDigit As String
End Sub

Public Sub Initialize (Callback As Object, EventName As String)
	mEventName = EventName
	mCallBack = Callback

	TF.Initialize("TF")
	MyDigit=""
End Sub

Public Sub DesignerCreateView (Base As Pane, Lbl As Label, Props As Map)
	mBase = Base
	
	LabelDigit=Lbl
	Lbl.Text="0.00"
	Base.AddNode(TF,-mBase.Width-50dip,0dip,50dip,mBase.Height)
	Base.AddNode(LabelDigit,0dip,0dip,mBase.Width,mBase.Height)
End Sub

Private Sub Base_Resize (Width As Double, Height As Double)
	LabelDigit.SetLayoutAnimated(0,0,0,Width,Height)
	TF.SetLayoutAnimated(0,-mBase.Width-50dip,0dip,50dip,mBase.Height)
End Sub

Public Sub GetBase As Pane
	Return mBase
End Sub

Public Sub RequestFocus
	TF.RequestFocus
End Sub

#Region Private

Private Sub TF_TextChanged (Old As String, New As String)
	If IsDigit(New)=False Or New.IndexOf(" ")>-1 Or New.IndexOf(".")>-1 Or New.IndexOf(",")>-1 Then 
		TF.Text=Old
		TF.SetSelection(TF.Text.Length,TF.Text.Length)
	Else
		Trasforma(New)
	End If
End Sub

Private Sub IsDigit(Text As String) As Boolean
	Private Digit As List = Array As String("0","1","2","3","4","5","6","7","8","9")
	If Text="" Then Text="0"
	Return  (Digit.IndexOf(Text.SubString(Text.Length-1))>-1)
End Sub

Private Sub Base_MousePressed (EventData As MouseEvent)
	TF.RequestFocus
	TF.Text=MyDigit
	TF.SetSelection(TF.Text.Length,TF.Text.Length)
End Sub

Private Sub Trasforma(Text As String)
	MyDigit=Text
	If Text.Length<3 Then
		LabelDigit.Text="0.00".SubString2(0,4-Text.Length) & Text
	Else
		LabelDigit.Text=Text.SubString2(0,Text.Length-2) & "." & Text.SubString(Text.Length-2)
	End If
End Sub

#End Region